#include "diamond_girl.h"
#include "BFont.h"

#include <SDL/SDL_gfxPrimitives.h>
#include <stdarg.h>

void button_draw(struct ui_object * this)
{
  int x, y, w, h;
  Uint8 c1, c2, c3;

  x = ui_object_x(this);
  y = ui_object_y(this);
  w = ui_object_width(this) - 1;
  h = ui_object_height(this) - 1;

  switch(ui_object_state(this))
    {
    default:
    case UI_OBJECT_STATE_NORMAL:
      c1 = 0x20;
      c2 = 0x80;
      c3 = 0x40;
      break;
    case UI_OBJECT_STATE_SELECTED:
      c1 = 0x40;
      c2 = 0xff;
      c3 = 0x80;
      break;
    case UI_OBJECT_STATE_ACTIVATED:
      c1 = 0x00;
      c2 = 0x80;
      c3 = 0xff;
      break;
    }

  hlineRGBA(gfx(MAP_SCREEN),     x, x + w,     y, 0x00, c2, c2, 0xff);
  hlineRGBA(gfx(MAP_SCREEN),     x, x + w, y + h, 0x00, c3, c3, 0xff);
  vlineRGBA(gfx(MAP_SCREEN),     x,     y, y + h, 0x00, c2, c2, 0xff);
  vlineRGBA(gfx(MAP_SCREEN), x + w,     y, y + h, 0x00, c3, c3, 0xff);
  x++;
  y++;
  w -= 2;
  h -= 2;
  hlineRGBA(gfx(MAP_SCREEN),     x, x + w,     y, 0x00, c2, c2, 0xff);
  hlineRGBA(gfx(MAP_SCREEN),     x, x + w, y + h, 0x00, c3, c3, 0xff);
  vlineRGBA(gfx(MAP_SCREEN),     x,     y, y + h, 0x00, c2, c2, 0xff);
  vlineRGBA(gfx(MAP_SCREEN), x + w,     y, y + h, 0x00, c3, c3, 0xff);
  x++;
  y++;
  w -= 2;
  h -= 2;
  {
    Uint32 c;
    SDL_Rect r;
  
    r.x = x;
    r.y = y;
    r.w = w + 1;
    r.h = h + 1;
    c = SDL_MapRGB(gfx(MAP_SCREEN)->format, 0x00, c1, c1);
    SDL_FillRect(gfx(MAP_SCREEN), &r, c);
  }
}

void button_draw_text(struct ui_object * this, char * fmt, ...)
{
  va_list ap;
  char buf[1024];

  button_draw(this);
  va_start(ap, fmt);
  vsnprintf(buf, sizeof buf, fmt, ap);
  va_end(ap);
  BFont_PrintString(gfx(MAP_SCREEN), ui_object_x(this) + 2, ui_object_y(this) + 2, "%s", buf);
  SDL_Flip(gfx(MAP_SCREEN));
}

void object_draw_text(struct ui_object * this, char * fmt, ...)
{
  va_list ap;
  char buf[1024];

  clear_area(ui_object_x(this), ui_object_y(this), ui_object_width(this), ui_object_height(this));
  va_start(ap, fmt);
  vsnprintf(buf, sizeof buf, fmt, ap);
  va_end(ap);
  BFont_PrintString(gfx(MAP_SCREEN), ui_object_x(this) + 2, ui_object_y(this) + 2, "%s", buf);
  SDL_Flip(gfx(MAP_SCREEN));
}
